package utils

import (
	"bufio"
	"encoding/json"
	"errors"
	"fmt"
	"os"
)

var ConfigPath = "config.json"

type Config struct {
	Version string
	Url     string
}

func ReadConfig() (*Config, error) {
	conf, err := os.Open(ConfigPath)
	if err != nil {
		fmt.Println(err)
		return nil, errors.New("打开文件失败")
	}
	reader := bufio.NewReader(conf)
	decoder := json.NewDecoder(reader)
	config := &Config{}
	err = decoder.Decode(config)
	if err != nil {
		return nil, errors.New("解析失败")
	}
	return config, nil
}

func WriteConfig(config *Config) error {
	data, err := json.MarshalIndent(config, "", "  ")
	if err != nil {
		fmt.Println(err)
		return errors.New("json marshal err")
	}
	err = os.WriteFile(ConfigPath, data, 0777)
	if err != nil {
		fmt.Println(err)
		return errors.New("写入配置文件出错")
	}
	return nil
}
