package utils

import (
	"encoding/json"
	"errors"
	"fmt"
	"io"
	"net/http"
)

func GetLatest(url string) (*Versions, error) {
	res, err := http.Get(url)
	if err != nil {
		fmt.Println(err)
		return nil, errors.New("get下载失败")
	}
	defer res.Body.Close()
	body, err := io.ReadAll(res.Body)
	if err != nil {
		fmt.Println(err)
		return nil, errors.New("version读取失败")
	}
	version := &Versions{}
	err = json.Unmarshal(body, version)
	if err != nil {
		fmt.Println(err)
		return nil, errors.New("unmarshal数据失败")
	}

	return version, nil
}
